unit dmMLang;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MultiLan;

const
  wm_SetLanguage = wm_User + 1;

procedure SwitchToLanguage(LangIndex: Integer);
procedure RefreshLanguage(AComponent: TComponent);
function GetMsg(const Id: String): String;

type
  TdmML = class(TDataModule)
    ML: TMultiLang;
    procedure MLChange(Sender: TMultiLang);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dmML: TdmML = nil;

implementation

{$R *.DFM}

procedure SwitchToLanguage(LangIndex: Integer);
begin
  if dmML.ML.LanguageIndex <> LangIndex
  then
    dmML.ML.LanguageIndex:=LangIndex;
end;

procedure RefreshLanguage(AComponent: TComponent);
begin
  dmML.ML.RefreshComponent(AComponent);
  if AComponent is TForm then
    TForm(AComponent).Perform(wm_SetLanguage, 0, dmML.ML.LanguageIndex);
end;

procedure TdmML.MLChange(Sender: TMultiLang);
var
  I: Integer;
begin
  for I:=0 to Screen.FormCount - 1 do
    Screen.Forms[I].Perform(wm_SetLanguage, 0, Sender.LanguageIndex);
end;

function GetMsg(const Id: String): String;
begin
  try
    Result:=dmML.ML.GetMsg(Id);
  except
    Result:=Id;
  end;
end;

end.
